import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import javax.media.jai.JAI;
import javax.media.jai.PlanarImage;
import java.util.*;
import java.awt.image.*;
import java.awt.image.renderable.*;
import javax.media.jai.*;
import javax.media.jai.operator.*;

public class ScaleDlg extends JInternalFrame implements ChangeListener {
    private JSlider m_slScaleValue;
    private PicEdit m_frmParent;
    
    public ScaleDlg(final PicEdit frmParent) {
        super("Skalieren...", false, true, false, true);
        this.m_frmParent = frmParent;
        getContentPane().setLayout(new BorderLayout());
        Point parentLoc = frmParent.getLocation();
        setLocation(parentLoc.x + 100, parentLoc.y + 100);
        
        m_slScaleValue = new JSlider(JSlider.HORIZONTAL, 1, 30, 10);
        Hashtable labels = new Hashtable();
        labels.put(new Integer(1), new JLabel("0.1"));
        labels.put(new Integer(10), new JLabel("1.0"));
        labels.put(new Integer(30), new JLabel("3.0"));
        m_slScaleValue.setLabelTable(labels);
        m_slScaleValue.setPaintLabels(true);
        m_slScaleValue.addChangeListener(this);
        
        JPanel panelButtons = new JPanel();
        JButton btnDo = new JButton("Anwenden");
        JButton btnUnDo = new JButton("Verwerfen");
        panelButtons.add(btnDo);
        panelButtons.add(btnUnDo);
        
        // Eventhandlers...
        btnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.setImage();
            }
        });
        btnUnDo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                frmParent.rollScaleBack();
            }
        });
        
        //Put everything together
        getContentPane().add(m_slScaleValue, BorderLayout.NORTH);
        getContentPane().add(panelButtons, BorderLayout.SOUTH);
        pack();
        frmParent.addChild(this);
    }
    
    public void stateChanged(ChangeEvent e) {
        int nScaleValue = m_slScaleValue.getValue();
        m_frmParent.scaleImage(nScaleValue);
    }
}